/**
 * Copyright (c) 2002-2013 "Neo Technology,"
 * Network Engine for Objects in Lund AB [http://neotechnology.com]
 *
 * This file is part of Neo4j.
 *
 * Neo4j is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
package org.neo4j.cypher.internal.parser.v1_9

import org.neo4j.cypher.internal.commands.expressions.{Literal, Expression}

trait SkipLimitClause extends Base {
  def skip: Parser[Expression] = ignoreCase("skip") ~> numberOrParam ^^ (x => x)

  def limit: Parser[Expression] = ignoreCase("limit") ~> numberOrParam ^^ (x => x)

  private def numberOrParam: Parser[Expression] =
    (positiveNumber ^^ (x => Literal(x.toInt))
      | parameter ^^ (x => x)
      | failure("expected positive integer or parameter"))
}





